/**
 * Copyright (c) 2004 - 2010 Eike Stepper (Berlin, Germany) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Eike Stepper - initial API and implementation
 */
package org.eclipse.emf.cdo.server.db;

import org.eclipse.emf.cdo.common.id.CDOID;
import org.eclipse.emf.cdo.server.IStoreAccessor;

import java.sql.Connection;

/**
 * @author Eike Stepper
 */
public interface IDBStoreAccessor extends IStoreAccessor
{
  public IDBStore getStore();

  public Connection getConnection();

  /**
   * @since 2.0
   */
  public IPreparedStatementCache getStatementCache();

  /**
   * @since 3.0
   */
  public boolean isNewObject(CDOID id);
}
